<script setup lang="ts">
import { ref, onMounted, reactive, watch } from "vue";
import type { QTableProps } from "quasar";

import { useQuasar } from "quasar";

import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";
import { checkPermission } from "@/utils/permissions";
import { updateCurrentPage } from "@/utils/function";
import { usePagination } from "@/composables/usePagination";

import type {
  DataOption,
  NewPagination,
  ListLinkGroup,
  Position,
} from "@/modules/01_masterdata/interface/index/Main";
import type {
  DataKPIGroup,
  DataKPIPosition,
  DataKPICapacity,
} from "@/modules/01_masterdata/interface/response/Main";

import Header from "@/components/DialogHeader.vue";

const $q = useQuasar();
const mixin = useCounterMixin();
const {
  dialogRemove,
  messageError,
  showLoader,
  hideLoader,
  success,
  dialogConfirm,
} = mixin;
const { pagination, params, onRequest, checkAndUpdatePage } = usePagination(
  "",
  getData
);

const id = ref<string>(""); // รหัสกลุ่มงานที่ต้องการแก้ไข
const modal = ref<boolean>(false); // เปิด/ปิด dialog
const editStatus = ref<boolean>(false); // สถานะการแก้ไข
const groupName = ref<Position | null>(); // กลุ่มงานที่เลือก
const position = ref<string[]>([]); // ตำแหน่งที่เลือก
const competency = ref<Position[]>([]); // สมรรถนะที่เลือก

const groupNameOp = ref<DataOption[]>([]); // กลุ่มงาน
const groupNameOpMain = ref<DataOption[]>([]); // กลุ่มงานหลัก
const positionOp = ref<DataOption[]>([]); // ตำแหน่ง
const positionMainOp = ref<DataOption[]>([]); // ตำแหน่งหลัก
const competencyOp = ref<DataOption[]>([]); // สมรรถนะ
const competencyOpMain = ref<DataOption[]>([]); // สมรรถนะหลัก

const rows = ref<ListLinkGroup[]>([]); // ข้อมูลเชื่อมโยงกับกลุ่มงานและตำแหน่ง
const keyword = ref<string>(""); // คำค้นหา
const columns = ref<QTableProps["columns"]>([
  {
    name: "groupName",
    align: "left",
    label: "กลุ่มงาน",
    sortable: true,
    field: "groupName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "positions",
    align: "left",
    label: "ตำแหน่ง",
    sortable: false,
    field: "positions",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "capacitys",
    align: "left",
    label: "สมรรถนะประจำกลุ่มงาน",
    sortable: false,
    field: "capacitys",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
]);
const visibleColumns = ref<string[]>(["groupName", "positions", "capacitys"]);

/** ฟังก์ชันดึงข้อมูลรายการเชื่อมโยงกับกลุ่มงานและตำแหน่ง */
async function getData() {
  showLoader();
  await http
    .get(config.API.kpiLink + "/edit", {
      params: {
        ...params.value,
        keyword: keyword.value.trim(),
      },
    })
    .then((res) => {
      const result = res.data.result;
      pagination.value.rowsNumber = result.total;
      rows.value = result.data;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ฟังก์ชันลบข้อมูลเชื่อมโยงกับกลุ่มงานและตำแหน่ง
 * @param id รหัสรายการข้อมูลเชื่อมโยงกับกลุ่มงานและตำแหน่ง
 */
async function deleteData(id: string) {
  showLoader();
  await http
    .delete(config.API.kpiLink + `/${id}`)
    .then(async () => {
      await checkAndUpdatePage(rows.value.length);
      await getData();
      success($q, "ลบข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/** ฟังก์ชันดึงข้อมูลกลุ่มงาน */
async function getListGroup() {
  await http
    .get(config.API.kpiGroup + `?pageSize=50`)
    .then(async (res) => {
      const dataOp = res.data.result.data;
      const uniqueNames = new Set();
      const filteredData = dataOp
        .filter((item: DataKPIGroup) => {
          if (!uniqueNames.has(item.id)) {
            uniqueNames.add(item.nameGroupKPI);
            return true;
          }
          return false;
        })
        .map((item: DataKPIGroup) => ({
          id: item.id,
          name: item.nameGroupKPI,
        }));

      groupNameOpMain.value = filteredData;
    })
    .catch((err) => {
      messageError($q, err);
    });
}

/** ฟังก์ชันดึงข้อมูลสมรรถนะ */
async function getCompetency() {
  await http
    .get(config.API.kpiCapacity + `?type=GROUP&pageSize=50`)
    .then(async (res) => {
      const dataOp = res.data.result.data;
      const uniqueNames = new Set();
      const filteredData = dataOp
        .filter((item: DataKPICapacity) => {
          if (!uniqueNames.has(item.id)) {
            uniqueNames.add(item.name);
            return true;
          }
          return false;
        })
        .map((item: DataKPICapacity) => ({
          id: item.id,
          name: item.name,
        }));

      competencyOpMain.value = filteredData;
    })
    .catch((err) => {
      messageError($q, err);
    });
}

/** ฟังก์ชันดึงข้อมูลตำแหน่ง */
async function getOptions() {
  await http
    .get(config.API.orgSalaryPosition)
    .then((res) => {
      const dataOp = res.data.result;
      const uniqueNames = new Set();
      const filteredData = dataOp
        .filter((item: DataKPIPosition) => {
          if (!uniqueNames.has(item.positionName)) {
            uniqueNames.add(item.positionName);
            return true;
          }
          return false;
        })
        .map((item: DataKPIPosition) => ({
          id: item.positionName,
          name: item.positionName,
        }));

      positionMainOp.value = filteredData;
    })
    .catch((err) => {
      messageError($q, err);
    });
}

/** ฟังก์ชันเปิด dialog เพิ่มข้อมูล */
async function onAdd() {
  showLoader();
  try {
    modal.value = true;
    await Promise.all([getOptions(), getListGroup(), getCompetency()]);
  } finally {
    hideLoader();
  }
}

/**
 * ฟังก์ชันเปิด dialog แก้ไข
 * @param rowId รหัสกลุ่มงานที่ต้องการแก้ไข
 */
async function onEdit(rowId: string) {
  showLoader();
  try {
    id.value = rowId;
    modal.value = true;
    editStatus.value = true;
    await Promise.all([getOptions(), getListGroup(), getCompetency()]);
    await getDataEdit(id.value);
  } finally {
    hideLoader();
  }
}

/**
 * ฟังก์ชันดึงข้อมูลสำหรับแก้ไข
 * @param id รหัสกลุ่มงานที่ต้องการแก้ไข
 */
async function getDataEdit(id: string) {
  await http
    .get(config.API.kpiLink + `/edit/${id}`)
    .then((res) => {
      const data = res.data.result;
      groupName.value = {
        id: data.groupId,
        name: data.groupName,
      };
      position.value = data.positions.map((i: Position) => i.name);
      competency.value = data.capacitys.map((i: DataKPICapacity) => ({
        id: i.id,
        name: i.name,
      }));
    })
    .catch((err) => {
      messageError($q, err);
    });
}

/** ฟังก์ชันบันทึกข้อมูล */
function onSubmit() {
  const url = editStatus.value
    ? config.API.kpiLink + `/${id.value}`
    : config.API.kpiLink;
  const body = {
    kpiGroupId: groupName.value?.id,
    positions: position.value,
    kpiCapacityIds: competency.value?.map((i: Position) => i.id),
  };
  dialogConfirm($q, async () => {
    showLoader();
    http[editStatus.value ? "put" : "post"](url, body)
      .then(async () => {
        await getData();
        success($q, "บันทึกสำเร็จ");
        close();
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/** ปิด dialog */
function close() {
  modal.value = false;
  editStatus.value = false;
  groupName.value = null;
  position.value = [];
  competency.value = [];
}

/**
 * ฟังก์ชันค้นหาข้อมูลของ Option
 * @param val ค่าที่ต้องการฟิลเตอร์
 * @param update  อัพเดทค่า
 * @param type ประเภทของ Option ที่ต้องการฟิลเตอร์
 */
function filterOptionSelect(val: string, update: Function, type: string) {
  switch (type) {
    case "group":
      update(() => {
        groupNameOp.value = groupNameOpMain.value.filter(
          (v: DataOption) => v.name.indexOf(val) > -1
        );
      });
      break;
    case "position":
      update(() => {
        positionOp.value = positionMainOp.value.filter(
          (v: DataOption) => v.name.indexOf(val) > -1
        );
      });
      break;
    case "competency":
      update(() => {
        competencyOp.value = competencyOpMain.value.filter(
          (v: DataOption) => v.name.indexOf(val) > -1
        );
      });

    default:
      break;
  }
}

/** ฟังก์ชันดึงข้อมูลใหม่ */
function fetchNewList() {
  pagination.value.page = 1;
  getData();
}

/** lifecycle hook */
onMounted(() => {
  getData();
});
</script>

<template>
  <q-toolbar style="padding: 0">
    <q-btn
      v-if="checkPermission($route)?.attrIsCreate"
      flat
      round
      color="primary"
      icon="add"
      @click="onAdd()"
    >
      <q-tooltip> เพิ่มข้อมูล </q-tooltip>
    </q-btn>
    <q-space />
    <div class="row q-gutter-sm">
      <q-input
        outlined
        dense
        v-model="keyword"
        label="ค้นหา"
        @keyup.enter="fetchNewList()"
      >
        <template v-slot:append> <q-icon name="search" /> </template
      ></q-input>
      <q-select
        v-model="visibleColumns"
        multiple
        outlined
        dense
        options-dense
        :display-value="$q.lang.table.columns"
        emit-value
        map-options
        :options="columns"
        option-value="name"
        style="min-width: 140px"
      >
      </q-select>
    </div>
  </q-toolbar>

  <p-table
    ref="table"
    :columns="columns"
    :rows="rows"
    row-key="id"
    flat
    bordered
    dense
    class="custom-header-table"
    :visible-columns="visibleColumns"
    :separator="'cell'"
    :rows-per-page-options="[10, 25, 50, 100]"
    @request="onRequest"
    v-model:pagination="pagination"
  >
    <template v-slot:header="props">
      <q-tr :props="props">
        <q-th auto-width />
        <q-th v-for="col in props.cols" :key="col.name" :props="props">
          <span class="text-weight-medium">{{ col.label }}</span>
        </q-th>
      </q-tr>
    </template>
    <template v-slot:body="props">
      <q-tr :props="props">
        <q-td auto-width>
          <q-btn
            v-if="
              checkPermission($route)?.attrIsGet &&
              checkPermission($route)?.attrIsUpdate
            "
            color="edit"
            flat
            dense
            round
            class="q-mr-xs"
            icon="edit"
            clickable
            @click="onEdit(props.row.id)"
          >
            <q-tooltip>แก้ไขข้อมูล</q-tooltip>
          </q-btn>
          <q-btn
            v-if="checkPermission($route)?.attrIsDelete"
            color="red"
            flat
            dense
            round
            icon="mdi-delete"
            clickable
            @click.stop="
              dialogRemove($q, async () => await deleteData(props.row.id))
            "
            v-close-popup
          >
            <q-tooltip>ลบข้อมูล</q-tooltip>
          </q-btn>
        </q-td>
        <q-td v-for="col in props.cols" :key="col.id" class="vertical-top">
          <div v-if="col.name == 'positions'">
            <div v-if="col.value.length !== 0">
              <div v-for="(pos, index) in col.value" :key="pos.id">
                {{ pos ? `- ${pos.name}` : "-" }}
              </div>
            </div>
            <div v-else>-</div>
          </div>
          <div v-else-if="col.name == 'capacitys'">
            <div v-if="col.value.length !== 0">
              <div v-for="competency in col.value" :key="competency.id">
                {{ competency ? `- ${competency.name}` : "-" }}
              </div>
            </div>
            <div v-else>-</div>
          </div>
          <div v-else>
            {{ col.value ? col.value : "-" }}
          </div>
        </q-td>
      </q-tr>
    </template>
  </p-table>

  <q-dialog v-model="modal" persistent>
    <q-card flat bordered style="min-width: 80vh">
      <q-form greedy @submit.prevent @validation-success="onSubmit">
        <Header
          :tittle="
            editStatus ? 'แก้ไขกลุ่มงานและตำแหน่ง' : 'เพิ่มกลุ่มงานและตำแหน่ง'
          "
          :close="close"
        />
        <q-separator />
        <q-card-section>
          <div class="row q-col-gutter-sm">
            <div class="col-4">
              <q-select
                dense
                v-model="groupName"
                label="กลุ่มงาน"
                outlined
                class="inputgreen"
                map-options
                option-label="name"
                option-value="id"
                :options="groupNameOp"
                use-input
                hide-selected
                fill-input
                @filter="(inputValue:string,doneFn:Function) => filterOptionSelect(inputValue, doneFn,'group') "
                hide-bottom-space
                lazy-rules
                :rules="[(val:string) => !!val || `${'กรุณาเลือกกลุ่มงาน'}`,]"
              >
                <template v-slot:no-option>
                  <q-item>
                    <q-item-section class="text-grey">
                      ไม่มีข้อมูล
                    </q-item-section>
                  </q-item>
                </template></q-select
              >
            </div>
            <div class="col-4">
              <q-select
                dense
                v-model="position"
                label="ตำแหน่ง"
                outlined
                multiple
                emit-value
                map-options
                class="inputgreen"
                option-label="name"
                option-value="name"
                :options="positionOp"
                :rules="[(val:string) => !!val || `${'กรุณาเลือกตำแหน่ง'}`,]"
                hide-bottom-space
                lazy-rules
                use-input
                @filter="(inputValue:string,doneFn:Function) => filterOptionSelect(inputValue, doneFn,'position') "
              >
                <template v-slot:no-option>
                  <q-item>
                    <q-item-section class="text-grey">
                      ไม่มีข้อมูล
                    </q-item-section>
                  </q-item>
                </template></q-select
              >
            </div>
            <div class="col-4">
              <q-select
                dense
                class="inputgreen"
                v-model="competency"
                label="สมรรถนะประจำกลุ่ม"
                outlined
                multiple
                map-options
                option-label="name"
                option-value="id"
                :rules="[(val:string) => !!val || `${'กรุณาเลือกสมรรถนะประจำกลุ่ม'}`,]"
                hide-bottom-space
                lazy-rules
                :options="competencyOp"
                use-input
                @filter="(inputValue:string,doneFn:Function) => filterOptionSelect(inputValue, doneFn,'competency') "
              >
                <template v-slot:no-option>
                  <q-item>
                    <q-item-section class="text-grey">
                      ไม่มีข้อมูล
                    </q-item-section>
                  </q-item>
                </template></q-select
              >
            </div>
          </div>
        </q-card-section>
        <q-separator />
        <q-card-actions align="right">
          <q-btn
            type="submit"
            for="#submitForm"
            class="q-px-md items-center"
            color="public"
            label="บันทึก"
          >
            <q-tooltip>บันทึกข้อมูล</q-tooltip>
          </q-btn>
        </q-card-actions>
      </q-form>
    </q-card>
  </q-dialog>
</template>
